/*
   A Solution to the Readers/Writers Problem Using Semaphores
   from "Operating Systems: Internals and Design principles", 5th Ed.,
   by Williams Stallings, page 243.

   Readers Have Priority
*/
int readcount = 0;
semaphore x = 1,
          writeSem = 1;


void reader()
{
   while (true)
   {
      semWait(x);
      readcount++;
      if (readcount == 1)
         semWait(writeSem);
      semSignal(x);
        read_data_base();       // access the data base
      semWait(x);
      readcount--;
      if (readcount == 0)
         semSignal(writeSem);
      semSignal(x);
      use_data_read();          // noncritical region
   }
}


void writer()
{
   while (true)
   {
      think_up_data();         // noncritical region
      semWait(writeSem);
        write_data_base();     // update the data base
      semSignal(writeSem);
   }
}

