/*
   Figure 5.23 A Solution to the Readers/Writers Problem Using
                Semaphores: Writers Have Priority

   Slightly modified.
*/
int readcount, writecount;
semaphore x = 1,
          y = 1,
          //z = 1,  // Not needed? (Give the writers slightly less priority.)
          wsem = 1,
          rsem = 1;

void reader()
{
   while (true)
   {
      //semWait(z);     // Give the writers slightly less priority.
      semWait(rsem);    // Notice that the wait and the signal
      semSignal(rsem);  // on rsem have been made consecutive.
      semWait(x);
        readcount++;
        if (readcount == 1)
           semWait(wsem);
      semSignal(x);
      //semSignal(z);   // Not needed??
      READUNIT();
      semWait(x);
        readcount--;
        if (readcount == 0)
           semSignal(wsem);
      semSignal(x);
   }
}

void writer()
{
   while (true)
   {
      semWait(y);
        writecount++;
        if (writecount == 1)
           semWait(rsem);
      semSignal(y);
      semWait(wsem);
        WRITEUNIT();
      semSignal(wsem);
      semWait(y);
        writecount--;
        if (writecount == 0)
           semSignal(rsem);
      semSignal(y);
   }
}

void main()
{
   readcount = writecount = 0;
   parbegin(reader, writer);
}
