#
# Notice that this make file uses the special gcc option -fforce-mem
# that forces gcc to use registers for what would otherwise be memory
# access only instructions.
#
CC = gcc
CFLAGS = -g -Wall -fverbose-asm -Wa,-a,-adhlns=$@.asm -fforce-mem

PROGRAM = race-subtle-example

all: $(PROGRAM)

$(PROGRAM): $(PROGRAM).c
	$(CC) $(CFLAGS) -o $@.exe $<

# delete only the files that we made
clean:
	rm -fv $(PROGRAM).asm $(PROGRAM).exe
