/*
    This program starts up two threads that each repeatedly
    print a single character to standard output, one thread
    outputs 'a' and the other thread outputs 'b'. In the output
    we see long stings of a's followed by long strings of b's.
    Each long string is from one thread running uninterrupted
    during its scheduled time quantum.
*/
#include <stdio.h>    // printf()
#include <unistd.h>   // sleep()
#include <pthread.h>

int main()
{
   //thread function prototypes
   void *thread1(void *vargp);
   void *thread2(void *vargp);

   pthread_t tid[2];

   // create threads
   printf("Starting threads\n");
   pthread_create(&(tid[0]), NULL, thread1, NULL);  // should have error checking
   pthread_create(&(tid[1]), NULL, thread2, NULL);

   while(1) // loop forever
   {
      sleep(10);  // try commenting out this line
   }

   return 0;
}//main


void *thread1(void *vargp)
{
   while(1) // loop forever
   {
      printf("a");
   }
   return NULL;
}//thread1


void *thread2(void *vargp)
{
   while(1) // loop forever
   {
      printf("b");
   }
   return NULL;
}//thread2
