/*
    This program starts up two threads that each repeatedly
    print a single character to standard output, one thread
    outputs 'a' and the other thread outputs 'b'. In the output
    we see long stings of a's followed by long strings of b's.
    Each long string is from one thread running uninterrupted
    during its scheduled time quantum.

    Be sure to run this program in both the foreground and in
    the background (a program runs in the "background" when its
    window is not the window that has focus). This demonstrates
    that Windows uses different time quantums for foreground
    and background threads.
*/
#include <windows.h>
#include <stdio.h>

int main()
{
   //thread function prototypes
   DWORD WINAPI thread1(LPVOID);
   DWORD WINAPI thread2(LPVOID);

   // create threads
   printf("Starting threads\n");
   CreateThread(NULL, 0, thread1, 0, 0, NULL);  // this should have error checking
   CreateThread(NULL, 0, thread2, 0, 0, NULL);

   while(1) // loop forever
   {
      Sleep(1000);  // try commenting out this line
   }

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   while(1) // loop forever
   {
      printf("a");
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   while(1) // loop forever
   {
      printf("b");
   }
   return 0;
}//thread2
